Loading...
Searching...
No Matches
seqan3::nucleotide_base< derived_type, size > Class Template Reference
Alphabet » Nucleotide

A CRTP-base that refines seqan3::alphabet_base and is used by the nucleotides. More...

`#include <seqan3/alphabet/nucleotide/nucleotide_base.hpp>`

Inheritance diagram for seqan3::nucleotide_base< derived_type, size >:
[legend]

## Public Member Functions

constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
Read functions
constexpr derived_type | complement () const noexcept
| Return the complement of the letter.
Public Member Functions inherited from seqan3::alphabet_base< derived_type, size, char >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr derived_type & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr derived_type & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Static Public Member Functions

static constexpr bool | char_is_valid (char_type const c) noexcept
| Validate whether a character value has a one-to-one mapping to an alphabet value.

## Static Public Attributes

static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Static Public Attributes inherited from seqan3::alphabet_base< derived_type, size, char >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.

## Constructors, destructor and assignment

template<typename other_nucl_type> requires (!std::same_as<nucleotide_base, other_nucl_type>) && (!std::same_as<derived_type, other_nucl_type>) && nucleotide_alphabet<other_nucl_type> && detail::convertable_to_through_char_representation<other_nucl_type, derived_type>
constexpr | nucleotide_base (other_nucl_type const &other) noexcept
| Allow explicit construction from any other nucleotide type and convert via the character representation.

## Additional Inherited Members

Protected Types inherited from seqan3::alphabet_base< derived_type, size, char >
using | char_type
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

template<typename derived_type, auto size>
class seqan3::nucleotide_base< derived_type, size >

A CRTP-base that refines seqan3::alphabet_base and is used by the nucleotides.

Template Parameters

  derived_type | The CRTP parameter type.
  size | The size of the alphabet.

You can use this class to define your own nucleotide alphabet, but types are not required to be based on it to model seqan3::nucleotide_alphabet, it is purely a way to avoid code duplication.

In addition to the requirements of seqan3::alphabet_base, the derived type needs to define the following static member variable (can be private):

- static std::array<THAT_TYPE, alphabet_size> complement_table that defines for every possible rank value the corresponding complement.

This entity is stable. Since version 3.1.

## Constructor & Destructor Documentation

## nucleotide_base()

template<typename derived_type, auto size>
template<typename other_nucl_type>
requires (!std::same_as<nucleotide_base, other_nucl_type>) && (!std::same_as<derived_type, other_nucl_type>) && nucleotide_alphabet<other_nucl_type> && detail::convertable_to_through_char_representation<other_nucl_type, derived_type>

seqan3::nucleotide_base< derived_type, size >::nucleotide_base | ( | other_nucl_type const & | other | ) |

inline explicit constexpr noexcept

Allow explicit construction from any other nucleotide type and convert via the character representation.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## Member Function Documentation

## char_is_valid()

template<typename derived_type, auto size>

constexpr bool seqan3::nucleotide_base< derived_type, size >::char_is_valid | ( | char_type const | c | ) |

inline static constexpr noexcept

Validate whether a character value has a one-to-one mapping to an alphabet value.

Satisfies the seqan3::semialphabet::char_is_valid_for() requirement via the seqan3::char_is_valid_for() wrapper.

Behaviour specific to nucleotides: True also for lower case letters that silently convert to their upper case and true also for U/T respectively, e.g. 'U' is a valid character for seqan3::dna4, because its informational content is identical to 'T'.

### Complexity

Constant.

### Exceptions

Guaranteed not to throw.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## complement()

template<typename derived_type, auto size>

derived_type seqan3::nucleotide_base< derived_type, size >::complement | ( |  | ) | const

inline constexpr noexcept

Return the complement of the letter.

See Nucleotide for the actual values.

Provides an implementation for seqan3::complement, required to model seqan3::nucleotide_alphabet.

### Complexity

Constant.

### Exceptions

Guaranteed not to throw.

This entity is stable. Since version 3.1.

## to_rank()

template<typename derived_type, auto size>

rank_type seqan3::alphabet_base< derived_type, size, char >::to_rank | ( |  | ) | const

inline constexpr noexcept

Return the letter's numeric value (rank in the alphabet).

Provides an implementation for seqan3::to_rank, required to model seqan3::semialphabet.

### Complexity

Constant.

### Exceptions

Guaranteed not to throw.

This entity is stable. Since version 3.1.

## Member Data Documentation

## alphabet_size

template<typename derived_type, auto size>

detail::min_viable_uint_t<size> seqan3::alphabet_base< derived_type, size, char >::alphabet_size

static constexpr

The size of the alphabet, i.e. the number of different values it can take.

This entity is stable. Since version 3.1.

The documentation for this class was generated from the following file:

- nucleotide_base.hpp

Hide me